<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户ID" />
      </el-form-item>
      <el-form-item label="分区编号" prop="partNo">
        <el-input v-model="formData.partNo" placeholder="请输入分区编号" />
      </el-form-item>
      <el-form-item label="业绩" prop="price">
        <el-input v-model="formData.price" placeholder="请输入业绩" />
      </el-form-item>
      <el-form-item label="是否碰撞 0为未碰撞 1为已碰撞" prop="hasHit">
        <el-input v-model="formData.hasHit" placeholder="请输入是否碰撞 0为未碰撞 1为已碰撞" />
      </el-form-item>
      <el-form-item label="碰撞后额度" prop="afterHitQuota">
        <el-input v-model="formData.afterHitQuota" placeholder="请输入碰撞后额度" />
      </el-form-item>
      <el-form-item label="是否是大区 0为小区 1为大区" prop="size">
        <el-input v-model="formData.size" placeholder="请输入是否是大区 0为小区 1为大区" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { PartitionSonApi, PartitionSonVO } from '@/api/system/distri/partitionson'

/** 后代分区 表单 */
defineOptions({ name: 'PartitionSonForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  partNo: undefined,
  price: undefined,
  hasHit: undefined,
  afterHitQuota: undefined,
  size: undefined
})
const formRules = reactive({
  hasHit: [{ required: true, message: '是否碰撞 0为未碰撞 1为已碰撞不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await PartitionSonApi.getPartitionSon(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as PartitionSonApi.PartitionSonVO
    if (formType.value === 'create') {
      await PartitionSonApi.createPartitionSon(data)
      message.success(t('common.createSuccess'))
    } else {
      await PartitionSonApi.updatePartitionSon(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    partNo: undefined,
    price: undefined,
    hasHit: undefined,
    afterHitQuota: undefined,
    size: undefined
  }
  formRef.value?.resetFields()
}
</script>